# UniTAP.dev.ports.modules.link.hdmi.frl_control_tx

class FfeMax:

Class `FfeMax` allows working with FFE on HDMI. Possible to configure:

- Set and get Value for mode 3 lanes and 3 Gbps `mode_3lanes_3gbps`.
- Set and get Value for mode 3 lanes and 6 Gbps `mode_3lanes_6gbps`.
- Set and get Value for mode 4 lanes and 6 Gbps `mode_4lanes_6gbps`.
- Set and get Value for mode 4 lanes and 8 Gbps `mode_4lanes_8gbps`.
- Set and get Value for mode 4 lanes and 10 Gbps `mode_4lanes_10gbps`.
- Set and get Value for mode 4 lanes and 12 Gbps `mode_4lanes_12gbps`.

FfeMax( mode_3lanes_3gbps: int = 0, mode_3lanes_6gbps: int = 0, mode_4lanes_6gbps: int = 0, mode_4lanes_8gbps: int = 0, mode_4lanes_10gbps: int = 0, mode_4lanes_12gbps: int = 0)
mode_3lanes_3gbps: int

Returns current value for mode 3 lanes and 3 Gbps.

###### Returns:

> object of int type

mode_3lanes_6gbps: int

Returns current value for mode 3 lanes and 6 Gbps.

###### Returns:

> object of int type

mode_4lanes_6gbps: int

Returns current value for mode 6 lanes and 6 Gbps.

###### Returns:

> object of int type

mode_4lanes_8gbps: int

Returns current value for mode 6 lanes and 8 Gbps.

###### Returns:

> object of int type

mode_4lanes_10gbps: int

Returns current value for mode 6 lanes and 10 Gbps.

###### Returns:

> object of int type

mode_4lanes_12gbps: int

Returns current value for mode 6 lanes and 12 Gbps.

###### Returns:

> object of int type

def value(self) -> int:

Returns current combined value from all modes.

###### Returns:

> object of int type

class FrlControlTx:

Class `FrlControlTx` contains information about FRL on Source (TX - transmitter) side. allows working with:

- Set and get FRL mode `frl_mode`.
- Set and get FRL capabilities `frl_caps`.
- Set and get FFE max `ffe_max`.
- Set and get LTP requested `ltp_pattern` and additional `ltp_additional_pattern`.
- Set link training timeout `lt_timeout` and link training poll timeout `lt_poll_timeout`.

FrlControlTx(port_io: UniTAP.libs.lib_tsi.tsi_io.PortIO)
ltp_pattern: UniTAP.dev.ports.modules.link.hdmi.types.LtpLanesPattern

Returns current LTP lanes pattern. Current Pattern that is being checking during Link Training. Each lane can request different pattern.

###### Returns:

> object of `LtpLanesPattern` type

ltp_additional_pattern: UniTAP.dev.ports.modules.link.hdmi.types.LtpLanesPattern

Returns current additional LTP lanes pattern. Current Pattern that is being checking during Link Training. Each lane can request different pattern.

###### Returns:

> object of `LtpLanesPattern` type

frl_caps: UniTAP.dev.ports.modules.link.hdmi.types.FrlCaps

Returns current FRL capabilities.

###### Returns:

> object of `FrlCaps` type

frl_mode: UniTAP.dev.ports.modules.link.hdmi.types.FrlMode

Returns current FRL mode.

###### Returns:

> object of `FrlMode` type

ffe_max: FfeMax

Returns current FFE MAX values.

###### Returns:

> object of `FfeMax` type

lt_timeout: int

Returns current value of link training timeout.

###### Returns:

> object of int type

lt_poll_timeout: int

Returns current value of link training poll timeout.

###### Returns:

> object of int type

def link_training(self):

Do link training.